/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.utils.flowVisualizationUtils;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.GroupLayout;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import org.visnow.vn.geometries.interactiveGlyphs.InteractiveGlyphGUI;
import org.visnow.vn.lib.gui.FieldBasedUI.DownsizeUI.DownsizeUI;
import org.visnow.vn.lib.gui.FieldBasedUI.IndexSliceUI.IndexSliceGUI;
import org.visnow.vn.lib.gui.FieldBasedUI.IndexSliceUI.IndexSliceParams;
import org.visnow.vn.lib.utils.flowVisualizationUtils.SeedPointParams.SeedPointsSelection;
import static org.visnow.vn.lib.utils.flowVisualizationUtils.SeedPointParams.SeedPointsSelection.*;

/**
 * @author know (Krzysztof S. Nowinski (know@icm.edu.pl)
 * Warsaw University, Interdisciplinary Centre
 * for Mathematical and Computational Modelling)
 */

public class SeedPointsGUI extends javax.swing.JPanel
{
    private SeedPointParams seedParams = new SeedPointParams();
    private int seedFieldType = -1;
    private int selectedFieldTrueDim = -1;
    private IndexSliceGUI indexSubsetGUI = new IndexSliceGUI(IndexSliceParams.Type.WHOLE);
    private IndexSliceParams indexSubsetParams;

    /**
     * Creates new form StreamlinesSeedPointsGUI
     */
    public SeedPointsGUI()
    {
        initComponents();
        indexSubsetPanel.add(indexSubsetGUI, BorderLayout.CENTER);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        buttonGroup1 = new ButtonGroup();
        buttonGroup2 = new ButtonGroup();
        buttonGroup3 = new ButtonGroup();
        buttonGroup4 = new ButtonGroup();
        typePanel = new JPanel();
        pointButton = new JRadioButton();
        wholeFieldButton = new JRadioButton();
        lineButton = new JRadioButton();
        lineSliceButton = new JRadioButton();
        planeButton = new JRadioButton();
        planarSliceButton = new JRadioButton();
        jPanel5 = new JPanel();
        selectorPanel = new JPanel();
        nullPanel = new JPanel();
        planarSliceControlPanel = new JPanel();
        linearSliceControlPanel = new JPanel();
        indexSubsetPanel = new JPanel();
        pointProbeControlPanel = new JPanel();
        downsizeUI1 = new DownsizeUI();

        setPreferredSize(new Dimension(281, 355));
        setRequestFocusEnabled(false);
        setLayout(new GridBagLayout());

        typePanel.setBorder(BorderFactory.createEtchedBorder());
        typePanel.setLayout(new GridLayout(0, 2));

        buttonGroup1.add(pointButton);
        pointButton.setText("point");
        pointButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                pointButtonActionPerformed(evt);
            }
        });
        typePanel.add(pointButton);

        buttonGroup1.add(wholeFieldButton);
        wholeFieldButton.setSelected(true);
        wholeFieldButton.setText("whole field"); // NOI18N
        wholeFieldButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                wholeFieldButtonActionPerformed(evt);
            }
        });
        typePanel.add(wholeFieldButton);

        buttonGroup1.add(lineButton);
        lineButton.setText("line"); // NOI18N
        lineButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                lineButtonActionPerformed(evt);
            }
        });
        typePanel.add(lineButton);

        buttonGroup1.add(lineSliceButton);
        lineSliceButton.setText("line probe");
        lineSliceButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                lineSliceButtonActionPerformed(evt);
            }
        });
        typePanel.add(lineSliceButton);

        buttonGroup1.add(planeButton);
        planeButton.setText("plane"); // NOI18N
        planeButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                planeButtonActionPerformed(evt);
            }
        });
        typePanel.add(planeButton);

        buttonGroup1.add(planarSliceButton);
        planarSliceButton.setText("planar slice");
        planarSliceButton.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent evt)
            {
                planarSliceButtonActionPerformed(evt);
            }
        });
        typePanel.add(planarSliceButton);

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(typePanel, gridBagConstraints);

        GroupLayout jPanel5Layout = new GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(jPanel5Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 325, Short.MAX_VALUE)
        );
        jPanel5Layout.setVerticalGroup(jPanel5Layout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 759, Short.MAX_VALUE)
        );

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(jPanel5, gridBagConstraints);

        selectorPanel.setBorder(BorderFactory.createEtchedBorder());
        selectorPanel.setMinimumSize(new Dimension(187, 400));
        selectorPanel.setOpaque(false);
        selectorPanel.setPreferredSize(new Dimension(200, 610));
        selectorPanel.setRequestFocusEnabled(false);
        selectorPanel.setLayout(new CardLayout());

        nullPanel.setVerifyInputWhenFocusTarget(false);

        GroupLayout nullPanelLayout = new GroupLayout(nullPanel);
        nullPanel.setLayout(nullPanelLayout);
        nullPanelLayout.setHorizontalGroup(nullPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 196, Short.MAX_VALUE)
        );
        nullPanelLayout.setVerticalGroup(nullPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 606, Short.MAX_VALUE)
        );

        selectorPanel.add(nullPanel, "null card");

        planarSliceControlPanel.setMinimumSize(new Dimension(200, 500));
        planarSliceControlPanel.setOpaque(false);
        planarSliceControlPanel.setPreferredSize(new Dimension(200, 600));
        planarSliceControlPanel.setVerifyInputWhenFocusTarget(false);
        planarSliceControlPanel.setLayout(new BorderLayout());
        selectorPanel.add(planarSliceControlPanel, "planar slice card");

        linearSliceControlPanel.setLayout(new BorderLayout());
        selectorPanel.add(linearSliceControlPanel, "linear slice card");

        indexSubsetPanel.setLayout(new BorderLayout());
        selectorPanel.add(indexSubsetPanel, "index subset panel");

        pointProbeControlPanel.setLayout(new BorderLayout());
        selectorPanel.add(pointProbeControlPanel, "point probe card");

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(selectorPanel, gridBagConstraints);
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(downsizeUI1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void lineButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_lineButtonActionPerformed
    {//GEN-HEADEREND:event_lineButtonActionPerformed
        seedTypeChanged();
    }//GEN-LAST:event_lineButtonActionPerformed

    private void planeButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_planeButtonActionPerformed
    {//GEN-HEADEREND:event_planeButtonActionPerformed
        seedTypeChanged();
    }//GEN-LAST:event_planeButtonActionPerformed

    private void wholeFieldButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_wholeFieldButtonActionPerformed
    {//GEN-HEADEREND:event_wholeFieldButtonActionPerformed
        seedTypeChanged();
    }//GEN-LAST:event_wholeFieldButtonActionPerformed

    private void planarSliceButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_planarSliceButtonActionPerformed
    {//GEN-HEADEREND:event_planarSliceButtonActionPerformed
        seedTypeChanged();
    }//GEN-LAST:event_planarSliceButtonActionPerformed

    private void lineSliceButtonActionPerformed(ActionEvent evt) {//GEN-FIRST:event_lineSliceButtonActionPerformed
        seedTypeChanged();
    }//GEN-LAST:event_lineSliceButtonActionPerformed

    private void pointButtonActionPerformed(ActionEvent evt)//GEN-FIRST:event_pointButtonActionPerformed
    {//GEN-HEADEREND:event_pointButtonActionPerformed
        seedTypeChanged();
    }//GEN-LAST:event_pointButtonActionPerformed

    public void setSeedParams(SeedPointParams seedParams)
    {
        this.seedParams = seedParams;
        seedParams.setGui(this);
        indexSubsetParams = seedParams.getIndexSliceParams();
        indexSubsetGUI.setParams(indexSubsetParams);
        downsizeUI1.setParams(seedParams.getDownsizeParams());
        updateFromParams();
    }

    public void setPlanarSliceGUI(InteractiveGlyphGUI planarSliceGUI)
    {
        planarSliceControlPanel.add(planarSliceGUI, BorderLayout.CENTER);
    }

    public void setLinearSliceGUI(InteractiveGlyphGUI linearSliceGUI)
    {
        linearSliceControlPanel.add(linearSliceGUI);
    }

    public void setPointProbeGUI(InteractiveGlyphGUI pointProbeGUI)
    {
        pointProbeControlPanel.add(pointProbeGUI);
    }

    private void selectorPanelUpdate()
    {
        int typePanelHeight = 88;
        typePanel.removeAll();
        switch (seedFieldType) {
        case -1:
            this.setVisible(false);
            return;
        case 0:
            typePanelHeight = 68;
            typePanel.setLayout(new GridLayout(2, 2));
            typePanel.add(pointButton);
            typePanel.add(wholeFieldButton);
            typePanel.add(lineSliceButton);
            if (selectedFieldTrueDim > 2)
                typePanel.add(planarSliceButton);
            this.setVisible(true);
            break;
        case 1:
            break;
        case 2:
            typePanelHeight = 68;
            typePanel.setLayout(new GridLayout(2, 2));
            typePanel.add(pointButton);
            typePanel.add(wholeFieldButton);
            typePanel.add(lineButton);
            typePanel.add(lineSliceButton);
            this.setVisible(true);
            break;
        case 3:
            typePanelHeight = 88;
            typePanel.setLayout(new GridLayout(3, 2));
            typePanel.add(pointButton);
            typePanel.add(wholeFieldButton);
            typePanel.add(lineButton);
            typePanel.add(lineSliceButton);
            typePanel.add(planeButton);
            typePanel.add(planarSliceButton);
            this.setVisible(true);
            break;
        }
        if (seedFieldType > 0) {
            int[] dims = seedParams.seedFieldDims();
            lineButton.setSelected(seedParams.getSelectionType() == SeedPointsSelection.LINE_SLICE);
            planeButton.setSelected(seedParams.getSelectionType() == SeedPointsSelection.PLANE_SLICE);
        }
        planarSliceButton.setVisible(selectedFieldTrueDim > 2);
        wholeFieldButton.setSelected(seedParams.getSelectionType() == SeedPointsSelection.WHOLE);
        CardLayout cl = (CardLayout)selectorPanel.getLayout();
        int selPanelHeight = 10;
        switch (seedParams.getSelectionType()) {
        case POINT:
            if (seedFieldType > 0) {
                cl.show(selectorPanel, "index subset panel");
                selPanelHeight = 260;
            }
            else {
                cl.show(selectorPanel, "point probe card");
                selPanelHeight = 340;
            }
            break;
        case LINE_SLICE:
        case PLANE_SLICE:
            cl.show(selectorPanel, "index subset panel");
            selPanelHeight = 260;
            break;
        case PLANAR_SLICE:
            cl.show(selectorPanel, "planar slice card");
            selPanelHeight =  430;
            break;
        case LINEAR_SLICE:
            cl.show(selectorPanel, "linear slice card");
            selPanelHeight = 340;
            break;
        case WHOLE:
            if (seedFieldType > 0) {
                cl.show(selectorPanel, "index subset panel");
                selPanelHeight = 260;
            }
            else {
                cl.show(selectorPanel, "null card");
                selPanelHeight = 10;
            }
            break;
        }
        Dimension size = new Dimension(180, selPanelHeight);
        selectorPanel.setMinimumSize(size);
        selectorPanel.setMaximumSize(size);
        selectorPanel.setPreferredSize(size);
        size = new Dimension(180, typePanelHeight);
        typePanel.setMinimumSize(size);
        typePanel.setMaximumSize(size);
        typePanel.setPreferredSize(size);

        Dimension panelSize = new Dimension(180, selPanelHeight + 150);
        setMinimumSize(panelSize);
        setMaximumSize(panelSize);
        setPreferredSize(panelSize);
    }

    public void updateFromParams()
    {
        if (seedParams == null)
            return;
        seedFieldType = seedParams.seedFieldType();
        selectedFieldTrueDim = seedParams.selectedFieldTrueDim;
        selectorPanelUpdate();
    }


    private void seedTypeChanged()
    {
        CardLayout cl = (CardLayout)selectorPanel.getLayout();
        if (seedParams != null) {
            seedParams.setActive(false);
            indexSubsetParams.setActive(false);
            if (pointButton.isSelected()) {
                if (seedFieldType < 0 )
                    cl.show(selectorPanel, "point probe card");
                else {
                    seedParams.setSeedPointsType(POINT);
                    indexSubsetParams.setType(IndexSliceParams.Type.POINT, false);
                    cl.show(selectorPanel, "index subset panel");
                }
            }
            if (lineButton.isSelected() && lineButton.isEnabled()) {
                cl.show(selectorPanel, "index subset panel");
                seedParams.setSeedPointsType(LINE_SLICE);
                indexSubsetParams.setType(IndexSliceParams.Type.LINE);
            }
            else if (planeButton.isSelected() && planeButton.isEnabled()) {
                cl.show(selectorPanel, "index subset panel");
                seedParams.setSeedPointsType(PLANE_SLICE);
                indexSubsetParams.setType(IndexSliceParams.Type.PLANE);
            }
            else if (wholeFieldButton.isSelected()) {
                if (seedFieldType < 0 )
                    cl.show(selectorPanel, "null card");
                else
                    cl.show(selectorPanel, "index subset panel");
                seedParams.setSeedPointsType(WHOLE);
            }
            else if (planarSliceButton.isSelected()) {
                cl.show(selectorPanel, "planar slice card");
                seedParams.setSeedPointsType(PLANAR_SLICE);
            }
            else if (lineSliceButton.isSelected()) {
                cl.show(selectorPanel, "linear slice card");
                seedParams.setSeedPointsType(LINEAR_SLICE);
//                indexSubsetParams.setType(IndexSliceParams.Type.WHOLE);
            }
            indexSubsetGUI.updateAxesButtons(seedParams.getSelectionType());
            seedParams.setActive(true);
            indexSubsetParams.setActive(true);
            updateFromParams();
        }
    }


    public boolean isAdjusting()
    {
        return seedParams.getDownsizeParams().isAdjusting();
    }



    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected ButtonGroup buttonGroup1;
    protected ButtonGroup buttonGroup2;
    protected ButtonGroup buttonGroup3;
    protected ButtonGroup buttonGroup4;
    protected DownsizeUI downsizeUI1;
    protected JPanel indexSubsetPanel;
    protected JPanel jPanel5;
    protected JRadioButton lineButton;
    protected JRadioButton lineSliceButton;
    protected JPanel linearSliceControlPanel;
    protected JPanel nullPanel;
    protected JRadioButton planarSliceButton;
    protected JPanel planarSliceControlPanel;
    protected JRadioButton planeButton;
    protected JRadioButton pointButton;
    protected JPanel pointProbeControlPanel;
    protected JPanel selectorPanel;
    protected JPanel typePanel;
    protected JRadioButton wholeFieldButton;
    // End of variables declaration//GEN-END:variables

}
